<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: src/LevelManager.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">LevelManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="LevelManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef LevelManager_H</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define LevelManager_H</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160; </div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;chrono&gt;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &lt;list&gt;</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">class </span><a class="code" href="structSpawnData.html">SpawnData</a>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">class </span><a class="code" href="classEnemy.html">Enemy</a>;</div>
<div class="line"><a name="l00016"></a><span class="lineno"><a class="line" href="classLevelManager.html">   16</a></span>&#160;<span class="keyword">class </span><a class="code" href="classLevelManager.html">LevelManager</a> {</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    <span class="keyword">static</span> <a class="code" href="classLevelManager.html">LevelManager</a>&amp; <a class="code" href="classLevelManager.html#ac7fc80999d7cea3833244b858f75aeb0">GetInstance</a>();</div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <a class="code" href="classLevelManager.html#a72ca9c27cc6b85143e20f83c520d1215">~LevelManager</a>();</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classLevelManager.html#afd79eedad898882d9a9f7f1e834c1776">Start</a>();</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classLevelManager.html#a7800611361e7c2ae99102e69429456fc">Update</a>();</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classLevelManager.html#ab77bc4254643d9af9d8f64620167ab32">LoadLevel</a>(std::string fname);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classLevelManager.html#acd28c2069a392266fa9698ba4aba2a05">CheckEndOfMap</a>();</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00061"></a><span class="lineno"><a class="line" href="classLevelManager.html#a5e12bdcc49e300a4e9f982e3c589f4fe">   61</a></span>&#160;    <a class="code" href="classLevelManager.html#a5e12bdcc49e300a4e9f982e3c589f4fe">LevelManager</a>(){}</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classLevelManager.html#a00727cc0a463c68e03773d0b99a45f2d">ParseLine</a>(<span class="keyword">const</span> std::string &amp; input, <span class="keywordtype">int</span> &amp; time, <span class="keywordtype">int</span> &amp; pos, <span class="keywordtype">int</span> &amp; type);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160; </div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classLevelManager.html#a0aa5999183349ffa57929d90649cc2d9">ParseColumn</a>(std::string::const_iterator &amp; it, std::string::const_iterator end, <span class="keywordtype">int</span> &amp; output);</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160; </div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classLevelManager.html#a31ec00edc2999008eaaba907d68d0250">ClearData</a>();</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="classEnemy.html">Enemy</a> * <a class="code" href="classLevelManager.html#a0dd819f5e75373256abed6dbfdc686dc">PopObject</a>();</div>
<div class="line"><a name="l00098"></a><span class="lineno"><a class="line" href="classLevelManager.html#af44b0e39305203531f089b8ab6459170">   98</a></span>&#160;    std::chrono::time_point&lt;std::chrono::system_clock&gt; <a class="code" href="classLevelManager.html#af44b0e39305203531f089b8ab6459170">m_Clock</a>; </div>
<div class="line"><a name="l00099"></a><span class="lineno"><a class="line" href="classLevelManager.html#a59512bd8b61c6d42e72b4e19b996ce7d">   99</a></span>&#160;    std::list&lt;SpawnData *&gt; <a class="code" href="classLevelManager.html#a59512bd8b61c6d42e72b4e19b996ce7d">m_ObjectToSpawn</a>; </div>
<div class="line"><a name="l00100"></a><span class="lineno"><a class="line" href="classLevelManager.html#a16da090cec97f6e3e0551ff85229bfc7">  100</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classLevelManager.html#a16da090cec97f6e3e0551ff85229bfc7">m_EndOfMap</a>; </div>
<div class="line"><a name="l00101"></a><span class="lineno"><a class="line" href="classLevelManager.html#acad7e80a4df9353e27dd46e80b3f58eb">  101</a></span>&#160;    <span class="keyword">const</span> <span class="keywordtype">int</span> <a class="code" href="classLevelManager.html#acad7e80a4df9353e27dd46e80b3f58eb">m_TypesEnemies</a> = 4; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160; </div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;};</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* LevelManager_H */</span><span class="preprocessor"></span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassLevelManager_html_acd28c2069a392266fa9698ba4aba2a05"><div class="ttname"><a href="classLevelManager.html#acd28c2069a392266fa9698ba4aba2a05">LevelManager::CheckEndOfMap</a></div><div class="ttdeci">bool CheckEndOfMap()</div><div class="ttdoc">Checks whenever level is finished.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:39</div></div>
<div class="ttc" id="aclassLevelManager_html_a16da090cec97f6e3e0551ff85229bfc7"><div class="ttname"><a href="classLevelManager.html#a16da090cec97f6e3e0551ff85229bfc7">LevelManager::m_EndOfMap</a></div><div class="ttdeci">bool m_EndOfMap</div><div class="ttdef"><b>Definition:</b> LevelManager.h:100</div></div>
<div class="ttc" id="aclassLevelManager_html"><div class="ttname"><a href="classLevelManager.html">LevelManager</a></div><div class="ttdoc">Mayer singlton class of LevelMagager which manages loading of level and spawning enemies.</div><div class="ttdef"><b>Definition:</b> LevelManager.h:16</div></div>
<div class="ttc" id="aclassLevelManager_html_a0aa5999183349ffa57929d90649cc2d9"><div class="ttname"><a href="classLevelManager.html#a0aa5999183349ffa57929d90649cc2d9">LevelManager::ParseColumn</a></div><div class="ttdeci">bool ParseColumn(std::string::const_iterator &amp;it, std::string::const_iterator end, int &amp;output)</div><div class="ttdoc">Parses collumn until field separator is met and saves it to the ouput parameter.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:91</div></div>
<div class="ttc" id="aclassLevelManager_html_a00727cc0a463c68e03773d0b99a45f2d"><div class="ttname"><a href="classLevelManager.html#a00727cc0a463c68e03773d0b99a45f2d">LevelManager::ParseLine</a></div><div class="ttdeci">bool ParseLine(const std::string &amp;input, int &amp;time, int &amp;pos, int &amp;type)</div><div class="ttdoc">Parses line input into output parameters.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:81</div></div>
<div class="ttc" id="aclassLevelManager_html_a72ca9c27cc6b85143e20f83c520d1215"><div class="ttname"><a href="classLevelManager.html#a72ca9c27cc6b85143e20f83c520d1215">LevelManager::~LevelManager</a></div><div class="ttdeci">~LevelManager()</div><div class="ttdoc">Destroy the Level Manager object.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:16</div></div>
<div class="ttc" id="aclassLevelManager_html_a59512bd8b61c6d42e72b4e19b996ce7d"><div class="ttname"><a href="classLevelManager.html#a59512bd8b61c6d42e72b4e19b996ce7d">LevelManager::m_ObjectToSpawn</a></div><div class="ttdeci">std::list&lt; SpawnData * &gt; m_ObjectToSpawn</div><div class="ttdef"><b>Definition:</b> LevelManager.h:99</div></div>
<div class="ttc" id="aclassLevelManager_html_a5e12bdcc49e300a4e9f982e3c589f4fe"><div class="ttname"><a href="classLevelManager.html#a5e12bdcc49e300a4e9f982e3c589f4fe">LevelManager::LevelManager</a></div><div class="ttdeci">LevelManager()</div><div class="ttdoc">Private constructor to achiave singleton pattern.</div><div class="ttdef"><b>Definition:</b> LevelManager.h:61</div></div>
<div class="ttc" id="aclassLevelManager_html_a7800611361e7c2ae99102e69429456fc"><div class="ttname"><a href="classLevelManager.html#a7800611361e7c2ae99102e69429456fc">LevelManager::Update</a></div><div class="ttdeci">void Update()</div><div class="ttdoc">Update messege from game loop spawns enemies if duration for spawning enemy has passed.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:26</div></div>
<div class="ttc" id="aclassLevelManager_html_a0dd819f5e75373256abed6dbfdc686dc"><div class="ttname"><a href="classLevelManager.html#a0dd819f5e75373256abed6dbfdc686dc">LevelManager::PopObject</a></div><div class="ttdeci">Enemy * PopObject()</div><div class="ttdoc">Pop Spawndata object from buffer and creates corresponding enemy.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:118</div></div>
<div class="ttc" id="aclassEnemy_html"><div class="ttname"><a href="classEnemy.html">Enemy</a></div><div class="ttdoc">Represents enemy, it shoots diferent type of projectiles and has chance to drop bonus on death.</div><div class="ttdef"><b>Definition:</b> Enemy.h:15</div></div>
<div class="ttc" id="aclassLevelManager_html_ab77bc4254643d9af9d8f64620167ab32"><div class="ttname"><a href="classLevelManager.html#ab77bc4254643d9af9d8f64620167ab32">LevelManager::LoadLevel</a></div><div class="ttdeci">bool LoadLevel(std::string fname)</div><div class="ttdoc">Loads level into a buffer.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:54</div></div>
<div class="ttc" id="astructSpawnData_html"><div class="ttname"><a href="structSpawnData.html">SpawnData</a></div><div class="ttdoc">Struct to store data from level file.</div><div class="ttdef"><b>Definition:</b> SpawnData.h:8</div></div>
<div class="ttc" id="aclassLevelManager_html_acad7e80a4df9353e27dd46e80b3f58eb"><div class="ttname"><a href="classLevelManager.html#acad7e80a4df9353e27dd46e80b3f58eb">LevelManager::m_TypesEnemies</a></div><div class="ttdeci">const int m_TypesEnemies</div><div class="ttdef"><b>Definition:</b> LevelManager.h:101</div></div>
<div class="ttc" id="aclassLevelManager_html_af44b0e39305203531f089b8ab6459170"><div class="ttname"><a href="classLevelManager.html#af44b0e39305203531f089b8ab6459170">LevelManager::m_Clock</a></div><div class="ttdeci">std::chrono::time_point&lt; std::chrono::system_clock &gt; m_Clock</div><div class="ttdef"><b>Definition:</b> LevelManager.h:98</div></div>
<div class="ttc" id="aclassLevelManager_html_ac7fc80999d7cea3833244b858f75aeb0"><div class="ttname"><a href="classLevelManager.html#ac7fc80999d7cea3833244b858f75aeb0">LevelManager::GetInstance</a></div><div class="ttdeci">static LevelManager &amp; GetInstance()</div><div class="ttdoc">Get the Instance object.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:11</div></div>
<div class="ttc" id="aclassLevelManager_html_a31ec00edc2999008eaaba907d68d0250"><div class="ttname"><a href="classLevelManager.html#a31ec00edc2999008eaaba907d68d0250">LevelManager::ClearData</a></div><div class="ttdeci">void ClearData()</div><div class="ttdoc">Clears buffer.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:110</div></div>
<div class="ttc" id="aclassLevelManager_html_afd79eedad898882d9a9f7f1e834c1776"><div class="ttname"><a href="classLevelManager.html#afd79eedad898882d9a9f7f1e834c1776">LevelManager::Start</a></div><div class="ttdeci">void Start()</div><div class="ttdoc">Start spawining enimies.</div><div class="ttdef"><b>Definition:</b> LevelManager.cpp:20</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
